/* oCADis
 * Copyright (C) 2001 Jonas Jarvoll
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* --  I N C L U D E S  -- */
#include <gtk/gtk.h>
#include "translation.h"
#include "struct.h"
#include "initmenu.h"
#include "layer.h"
#include "misc.h"
#include "dia_message.h"


/* --  G L O B A L   V A R I A B L E S  -- */

/* --  L O C A L   V A R I A B L E S  -- */
static GtkWidget *dia_window;
static GtkWidget *dia_table;

static GtkWidget *dia_close_button;


static DOCUMENT *grab_document;

/* --  P R O T O T Y P E S  -- */
static gint layer_close(GtkWidget *widget, gpointer data)
{
  gtk_widget_hide(dia_window);
  menus_set_sensitive("/Assist/Format/Layer...", TRUE);
  return TRUE;
}

void dia_show_layer(GtkWidget *widget, gpointer data)
{
  grab_document=get_document();
  if(grab_document!=NULL)
    {
      menus_set_sensitive("/Assist/Format/Layer...", FALSE);
      //      drawaids_set_dialog(grab_document);
      gtk_widget_show(dia_window);
    }
  else
    message(0, "No active drawing found.\nPlease make a new drawing or open an existing drawing.");

}

void make_dialog_layer(void)
{
  /* Create main window */
  dia_window=gtk_dialog_new();

  /* Set window title */
  gtk_window_set_title(GTK_WINDOW(dia_window),"oCADis: Layers");

  gtk_window_set_modal(GTK_WINDOW(dia_window),TRUE);

  /* Attach signals to window */
  gtk_signal_connect(GTK_OBJECT(dia_window),"delete_event",
                     GTK_SIGNAL_FUNC(layer_close),NULL);

  /* Make table */
  dia_table=gtk_table_new(3,2,FALSE);
  gtk_widget_show(dia_table);

  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dia_window)->vbox),dia_table,TRUE,TRUE,0);

  /* Make buttons */
  dia_close_button=gtk_button_new_with_label("Close");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dia_window)->action_area),
		      dia_close_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (dia_close_button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (dia_close_button);
  gtk_signal_connect(GTK_OBJECT(dia_close_button),"clicked",
		     GTK_SIGNAL_FUNC(layer_close), NULL); 
  gtk_widget_show (dia_close_button);
}



