/* oCADis
 * Copyright (C) 2001 Jonas Jarvoll
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* --  I N C L U D E S  -- */
#include <gtk/gtk.h>
#include <stdio.h>
#include "translation.h"
#include "struct.h"
#include "initmenu.h"
#include "misc.h"
#include "dia_message.h"
#include "graphics/ocadis.xpm"


/* --  G L O B A L   V A R I A B L E S  -- */

/* --  L O C A L   V A R I A B L E S  -- */
static GtkWidget *dia_window;

static GtkWidget *dia_pixmap;

static GdkPixmap *pixmap;
static GdkBitmap *mask;

static GtkWidget *dia_close_button;

static GtkWidget *dia_text;

/* --  P R O T O T Y P E S  -- */
static gint about_close(GtkWidget *widget, gpointer data)
{
  gtk_widget_hide(dia_window);
  menus_set_sensitive("/Help/_About oCADis", TRUE);
  return TRUE;
}

void dia_show_about(GtkWidget *widget, gpointer data)
{
  menus_set_sensitive("/Help/_About oCADis", FALSE);
  gtk_widget_show(dia_window);
}

void make_dialog_about(void)
{
  gchar t[255];

  /* Create main window */
  dia_window=gtk_dialog_new();
  gtk_widget_realize(dia_window);

  /* Set window title */
  gtk_window_set_title(GTK_WINDOW(dia_window),_("oCADis: About oCADis"));
  gtk_widget_set_usize(GTK_WIDGET(dia_window), 250,370);

  /* Attach signals to window */
  gtk_signal_connect(GTK_OBJECT(dia_window),"delete_event",
                     GTK_SIGNAL_FUNC(about_close),NULL);

  /* Make logotype */
  pixmap = gdk_pixmap_create_from_xpm_d (dia_window->window,
					 &mask, NULL, ocadis);
  dia_pixmap=gtk_pixmap_new(pixmap, mask);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dia_window)->vbox),dia_pixmap,TRUE,TRUE,0);
  gtk_widget_show(dia_pixmap);

  /* Make buttons */
  dia_close_button=gtk_button_new_with_label(_("Close"));
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dia_window)->action_area),
		      dia_close_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (dia_close_button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (dia_close_button);
  gtk_signal_connect(GTK_OBJECT(dia_close_button),"clicked",
		     GTK_SIGNAL_FUNC(about_close), NULL); 
  gtk_widget_show (dia_close_button);

  /* Make text */
  sprintf(t, _("%s\nA 2D mechanical CAD-application.\n\nVersion %s\n\nCopyright (C)2000 Jonas Jarvoll\n\nContact: jonas@nocrew.org\n\n%s is released under GPL.\n"), PACKAGE, VERSION, PACKAGE);
  dia_text=gtk_label_new(t);
  gtk_widget_show(dia_text);

  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dia_window)->vbox),dia_text,TRUE,TRUE,0);
}












