/* oCADis
 * Copyright (C) 2001 Jonas Jarvoll
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* --  I N C L U D E S  -- */
#include <gtk/gtk.h>
#include "struct.h"
#include "global.h"
#include "initmenu.h"
#include "layer.h"
#include "misc.h"
#include "dia_message.h"
#include "translation.h"

/* --  G L O B A L   V A R I A B L E S  -- */

/* --  L O C A L   V A R I A B L E S  -- */
static GtkWidget *dia_window;
static GtkWidget *dia_table;

static GtkWidget *dia_ok_button;
static GtkWidget *dia_cancel_button;
static GtkWidget *dia_all_button;

static GtkWidget *dia_option;
static GtkWidget *dia_menu;

static GtkWidget *dia_label_1;
static GtkWidget *dia_label_2;
static GtkWidget *dia_label_3;

static GtkWidget *dia_select_check[16];

static GtkObject *dia_adj;
static GtkWidget *dia_scale;

static gint sel_option_menu;

/* --  P R O T O T Y P E S  -- */
static void select_set_dialog(void)
{
  sel_option_menu=gl_select_apply_to;
  gtk_option_menu_set_history(GTK_OPTION_MENU(dia_option),gl_select_apply_to);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[0]), (gl_select_mask & TYPE_LINE) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[1]), (gl_select_mask & TYPE_POLYLINE) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[2]), (gl_select_mask & TYPE_RLINE) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[3]), (gl_select_mask & TYPE_CLINE) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[4]), (gl_select_mask & TYPE_SPLINE) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[5]), (gl_select_mask & TYPE_ARC) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[6]), (gl_select_mask & TYPE_CIRCLE) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[7]), (gl_select_mask & TYPE_ELLIPSE) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[8]), (gl_select_mask & TYPE_ELARC) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[9]), (gl_select_mask & TYPE_POINT) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[10]), (gl_select_mask & TYPE_TEXT) );
  //  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[11]), (gl_select_mask & TYPE_BLOCK_L) );
  // gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[12]), (gl_select_mask & TYPE_BLOCK_E) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[13]), (gl_select_mask & TYPE_ATTRIBUTE) );
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[14]), (gl_select_mask & TYPE_HATCH) );

  gtk_adjustment_set_value(GTK_ADJUSTMENT(dia_adj), gl_select_sensitivity);
}

static void select_get_dialog(void)
{ 
  gl_select_apply_to=sel_option_menu; 

  gl_select_mask=0;

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[0])))
    gl_select_mask= gl_select_mask | TYPE_LINE;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[1])))
    gl_select_mask= gl_select_mask | TYPE_POLYLINE;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[2])))
    gl_select_mask= gl_select_mask | TYPE_RLINE;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[3])))
    gl_select_mask= gl_select_mask | TYPE_CLINE;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[4])))
    gl_select_mask = gl_select_mask | TYPE_SPLINE;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[5])))
    gl_select_mask = gl_select_mask | TYPE_ARC;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[6])))
    gl_select_mask= gl_select_mask | TYPE_CIRCLE;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[7])))
    gl_select_mask = gl_select_mask | TYPE_ELLIPSE;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[8])))
    gl_select_mask = gl_select_mask | TYPE_ELARC;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[9])))
    gl_select_mask = gl_select_mask | TYPE_POINT;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[10])))
    gl_select_mask = gl_select_mask | TYPE_TEXT;
  //  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[11])))
  //  gl_select_mask = gl_select_mask | TYPE_BLOCK_L;   
  // if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[12])))
  //  gl_select_mask = gl_select_mask | TYPE_BLOCK_E;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[13])))
    gl_select_mask = gl_select_mask | TYPE_ATTRIBUTE;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dia_select_check[14])))
    gl_select_mask = gl_select_mask | TYPE_HATCH;

  gl_select_sensitivity=GTK_ADJUSTMENT(dia_adj)->value;
}

static gint change_option(GtkWidget *widget, gint data)
{
  sel_option_menu=data;
  return TRUE;
}

static gint select_all(GtkWidget *widget, gpointer data)
{
  gint i;

  for(i=0;i<16;i++)
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (dia_select_check[i]), TRUE );
  return TRUE;
}

static gint select_ok(GtkWidget *widget, gpointer data)
{
  select_get_dialog();
  gtk_widget_hide(dia_window);
  menus_set_sensitive("/Assist/Selection...", TRUE);
  return TRUE;
}

static gint select_cancel(GtkWidget *widget, gpointer data)
{
  gtk_widget_hide(dia_window);
  menus_set_sensitive("/Assist/Selection...", TRUE);
  return TRUE;
}

void dia_show_select(GtkWidget *widget, gpointer data)
{
  menus_set_sensitive("/Assist/Selection...", FALSE);
  select_set_dialog();
  gtk_widget_show(dia_window);
}

void make_dialog_select(void)
{
  GtkWidget *menu;
  gint i;

  /* Create main window */
  dia_window=gtk_dialog_new();

  /* Set window title */
  gtk_window_set_title(GTK_WINDOW(dia_window), _("oCADis: Selection"));

  gtk_window_set_modal(GTK_WINDOW(dia_window),TRUE);

  gtk_widget_set_usize(GTK_WIDGET(dia_window),320,340);

  /* Attach signals to window */
  gtk_signal_connect(GTK_OBJECT(dia_window),"delete_event",
		      GTK_SIGNAL_FUNC(select_cancel),NULL);
  
  /* Make table */
  dia_table=gtk_table_new(3,12,FALSE);
  gtk_widget_show(dia_table);
  
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dia_window)->vbox),dia_table,TRUE,TRUE,0);
  
  /* Make options */
  dia_option=gtk_option_menu_new();
  gtk_widget_show(dia_option);
  dia_menu=gtk_menu_new();
  gtk_option_menu_set_menu(GTK_OPTION_MENU(dia_option),dia_menu);
  
  menu=gtk_menu_item_new_with_label( _("Current Layer"));
  gtk_signal_connect(GTK_OBJECT(menu),"activate",
		     GTK_SIGNAL_FUNC (change_option),
		     (gpointer)APPLY_CURRENT_LAYER);
  gtk_widget_show(menu);  
  gtk_menu_append(GTK_MENU(dia_menu), menu);
  menu=gtk_menu_item_new_with_label( _("All Layers"));
  gtk_signal_connect(GTK_OBJECT(menu),"activate",
		     GTK_SIGNAL_FUNC (change_option),
		     (gpointer)APPLY_ALL_LAYERS);
  gtk_widget_show(menu);  
  gtk_menu_append(GTK_MENU(dia_menu), menu);
  menu=gtk_menu_item_new_with_label( _("All Layers but Current"));
  gtk_signal_connect(GTK_OBJECT(menu),"activate",
		     GTK_SIGNAL_FUNC (change_option),
		     (gpointer)APPLY_ALL_LAYERS_BUT_CURRENT);
  gtk_widget_show(menu);  
  gtk_menu_append(GTK_MENU(dia_menu), menu);
  
  
  gtk_table_attach(GTK_TABLE(dia_table), dia_option,1,3,0,1,
		   GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_FILL|GTK_EXPAND|GTK_SHRINK,0,0);
  
  /* Make label */
  dia_label_1=gtk_label_new( _("Apply to: "));
  gtk_table_attach(GTK_TABLE(dia_table), dia_label_1,0,1,0,1,
		   GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_FILL|GTK_EXPAND|GTK_SHRINK,0,0);
  dia_label_2=gtk_label_new( _("Selection mask: "));
  gtk_table_attach(GTK_TABLE(dia_table), dia_label_2,0,1,1,2,
		   GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_FILL,0,0);
  dia_label_3=gtk_label_new( _("Sensitivity: \n(in pixels) "));
  gtk_table_attach(GTK_TABLE(dia_table), dia_label_3,0,1,10,11,
		   GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_FILL|GTK_EXPAND|GTK_SHRINK,0,0);
  
  gtk_misc_set_alignment(GTK_MISC(dia_label_1),1.0,0.5);
  gtk_misc_set_alignment(GTK_MISC(dia_label_2),1.0,0.5);
  gtk_misc_set_alignment(GTK_MISC(dia_label_3),1.0,0.5);
  
  gtk_widget_show(dia_label_1);
  gtk_widget_show(dia_label_2);
  gtk_widget_show(dia_label_3);
  
  /* Make radio buttons */
  dia_select_check[0]=gtk_check_button_new_with_label( _("Line"));
  dia_select_check[1]=gtk_check_button_new_with_label( _("Polyline"));
  dia_select_check[2]=gtk_check_button_new_with_label( _("Ray"));
  dia_select_check[3]=gtk_check_button_new_with_label( _("Construction line"));
  dia_select_check[4]=gtk_check_button_new_with_label( _("Spline"));
  dia_select_check[5]=gtk_check_button_new_with_label( _("Arc"));
  dia_select_check[6]=gtk_check_button_new_with_label( _("Circle"));
  dia_select_check[7]=gtk_check_button_new_with_label( _("Ellipse"));
  dia_select_check[8]=gtk_check_button_new_with_label( _("Ellipse arc"));
  dia_select_check[9]=gtk_check_button_new_with_label( _("Point"));
  dia_select_check[10]=gtk_check_button_new_with_label( _("Text"));
  dia_select_check[11]=gtk_check_button_new_with_label( _("Block Local"));
  dia_select_check[12]=gtk_check_button_new_with_label( _("Block Extern"));
  dia_select_check[13]=gtk_check_button_new_with_label( _("Attribute"));
  dia_select_check[14]=gtk_check_button_new_with_label( _("Hatch"));
  dia_select_check[15]=gtk_check_button_new_with_label( _("Dimensions"));

  for(i=0;i<8;i++)
    {
      gtk_widget_show(dia_select_check[i]);

      gtk_table_attach(GTK_TABLE(dia_table), dia_select_check[i],1,2,i+1,i+1+1,
		       GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_FILL,0,0);     
    }

  for(i=0;i<8;i++)
    {
      gtk_widget_show(dia_select_check[i+8]);

      gtk_table_attach(GTK_TABLE(dia_table), dia_select_check[i+8],2,3,i+1,i+1+1,
		       GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_FILL,0,0);     
    }

  /* Make ranger */
  dia_adj = gtk_adjustment_new (1.0, 1.0, 10.0, 1.0, 1.0, 0.0);
  dia_scale = gtk_hscale_new (GTK_ADJUSTMENT (dia_adj));
  gtk_scale_set_digits (GTK_SCALE (dia_scale), 0);
  gtk_table_attach(GTK_TABLE(dia_table), dia_scale,1,3,10,11,
		   GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_FILL|GTK_EXPAND|GTK_SHRINK,0,0);
  gtk_widget_show (dia_scale);


  /* Make buttons */
  dia_all_button=gtk_button_new_with_label( _("All"));
  gtk_table_attach(GTK_TABLE(dia_table), dia_all_button,1,3,9,10,
		       GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_FILL,0,0);
  gtk_signal_connect(GTK_OBJECT(dia_all_button),"clicked",
      GTK_SIGNAL_FUNC(select_all), NULL);
  gtk_widget_show(dia_all_button);

  dia_ok_button=gtk_button_new_with_label( _("OK"));
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dia_window)->action_area),
		      dia_ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (dia_ok_button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (dia_ok_button);
  gtk_signal_connect(GTK_OBJECT(dia_ok_button),"clicked",
      GTK_SIGNAL_FUNC(select_ok), NULL);
  gtk_widget_show (dia_ok_button);

  dia_cancel_button=gtk_button_new_with_label( _("Cancel"));
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dia_window)->action_area),
		      dia_cancel_button, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(dia_cancel_button),"clicked",
		     GTK_SIGNAL_FUNC(select_cancel), NULL); 
  gtk_widget_show (dia_cancel_button);
}








