/* oCADis
 * Copyright (C) 2001 Jonas Jarvoll
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* --  I N C L U D E S  -- */
#include <gtk/gtk.h>
#include "struct.h"
#include "struct/grdraw.h"
#include "misc.h"
#include "dimension.h"
#include "draw.h"

/* --  G L O B A L   V A R I A B L E S  -- */

/* --  L O C A L   V A R I A B L E S  -- */

/* -- Select dimension lines -- */
static gboolean gl_dim_select;
static gdouble select_mx, select_my;
static gdouble select_d;


/* --  F U N C T I O N S  -- */
static void dim_select_line(DOCUMENT *doc, GdkGC *gc, gdouble x1, gdouble y1, gdouble x2, gdouble y2)
{
  if(!gl_dim_select && misc_point_on_line(select_mx, select_my, x1, y1, x2, y2, select_d))
     gl_dim_select=TRUE;
}

static void dim_select_arc(DOCUMENT *doc, GdkGC *gc, gdouble xcen, gdouble ycen, gdouble radius, 
			  gdouble sangle, gdouble eangle)
{
  OBJECT_ARC arc;

  arc.centrum.x=xcen;
  arc.centrum.y=ycen;
  arc.radius=radius;
  arc.start_angle=sangle;
  arc.end_angle=eangle;

  if(!gl_dim_select && misc_point_on_arc(select_mx, select_my, &arc, select_d))
     gl_dim_select=TRUE;
}

static void dim_select_arrow(DOCUMENT *doc, GdkGC *gc, gdouble x, gdouble y, gdouble angle,gdouble size)
{
  /* This is to do */
}

static void dim_select_text(DOCUMENT *doc, GdkGC *gc, gint just, gdouble x, gdouble y, 
			    gdouble height, gdouble width, gdouble rot, gchar *text)
{
  if(!gl_dim_select && select_text(select_mx, select_my, select_d, just, x, y, 
				   height, width, rot, text))
    gl_dim_select=TRUE;
}

static GRDRAW gr_select_draw={dim_select_line, dim_select_arc, dim_select_arrow,dim_select_text};

/* --  M O R E  F U N C T I O N S  -- */
gint dim_select_dimension(DOCUMENT *doc, OBJECT *obj, gdouble x, gdouble y, gdouble d)
{
  gl_dim_select=FALSE;

  /* Init global variables */
  select_mx=x;
  select_my=y;
  select_d=d;

  dim_draw_dimension(doc, &gr_select_draw, obj);

  return gl_dim_select;
}


