/* oCADis
 * Copyright (C) 2001 Jonas Jarvoll
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* --  I N C L U D E S  -- */
#include <gtk/gtk.h>
#include <math.h>
#include "struct.h"
#include "calc.h"
#include "misc.h"
#include "dia_comm.h"
#include "draw.h"
#include "translation.h"

/* --  G L O B A L   V A R I A B L E S  -- */

/* --  L O C A L   V A R I A B L E S  -- */


/* --  F U N C T I O N S  -- */
static void draw_isogrid(DOCUMENT *doc)
{
}

static void draw_grid_negative(DOCUMENT *doc)
{
}

static void draw_grid_positive(DOCUMENT *doc)
{
  gdouble rot;
  gdouble tx,ty;
  gdouble dw,dh;
  gdouble sx,sy;
  gdouble x,y;
  gint exit;
  gdouble winx,winy,winw,winh;

  rot=doc->gl_snap_angle;

  dw=doc->gl_snap_width*doc->gl_grid_x;
  dh=doc->gl_snap_height*doc->gl_grid_y;

  if(WLDtoSCR(doc,dw)<2 || WLDtoSCR(doc,dh)<2)
    {
      print( _("\n  Grid too dense to be diplayed."));
      set_prompt();
      return;
    }
  /* Find coordinates of draw window */
  winx=SCRtoWLD_x(doc,0);
  winy=SCRtoWLD_y(doc,0);
  winw=SCRtoWLD(doc,doc->widgets.draw->allocation.width);
  winh=SCRtoWLD(doc,doc->widgets.draw->allocation.height);

  x=doc->gl_snap_basex;
  y=doc->gl_snap_basey;

  misc_rotate_point(rot,doc->gl_snap_basex,doc->gl_snap_basey,&x,&y);
  misc_rotate_point(rot,doc->gl_snap_basex,doc->gl_snap_basey,&winx,&winy);

  /* Find first point on screen */
  while(x<winx)
    x+=dw;

  while(y<winy)
    y+=dh;

  while(x>winx)
    x-=dw;

  while(y>winy)
    y-=dh;

  exit=FALSE;
  for(sy=y;!exit;sy+=dh)
    {
      for(sx=x;;sx+=dw)
	{
	  tx=sx;
	  ty=sy;
	  misc_rotate_point(-rot,doc->gl_snap_basex,doc->gl_snap_basey,&tx,&ty);
	  set_point(doc,doc->gl_grid,tx,ty);
	  
	  if(WLDtoSCR_x(doc,tx)>doc->widgets.draw->allocation.width)
	    break;       
	}
      exit=(WLDtoSCR_y(doc,ty)>doc->widgets.draw->allocation.height);
    }
  
  exit=FALSE;
  for(sy=y;!exit;sy+=dh)
    {
      for(sx=x;;sx-=dw)
	{
	  tx=sx;
	  ty=sy;
	  misc_rotate_point(-rot,doc->gl_snap_basex,doc->gl_snap_basey,&tx,&ty);
	  set_point(doc,doc->gl_grid,tx,ty);
	  
	  if(WLDtoSCR_x(doc,tx)<0)
	    break;
	}
      
      exit=(WLDtoSCR_y(doc,ty)>doc->widgets.draw->allocation.height*2);
    }
}


void draw_grid(DOCUMENT *doc)
{
  if(doc->gl_iso_view)
    draw_isogrid(doc);
  else if(doc->gl_snap_angle<0.0)
    draw_grid_negative(doc);
  else
    draw_grid_positive(doc);
}




