/*

How to write program-interface ? (tangent to tree)

1. Select three objects into field OBJECT **obj;
   Check if object1 != object2 != object3
   Check if type of objects is in (TYPE_POINT, TYPE_LINE,
   TYPE_CIRCLE, TYPE_ARC)
2. Call function apollonius.
   This function returns three fields x,y,r and nsol.
   (If there was unposible to find solution, then  nsol=0)
3. Draw nsol points.
4. When cursor moves on screen, check distance between cursor
   and points. Use function "find_nearest_circle"
   Draw circle, nearest to cursor.
5. Last click of mouse button (4-th click) hides points and draws
   circle last displayed .

Program-interface for secound problem is similar.

*/

void math_find_nearest_circle(gdouble   *xc,    /* field of found circles */
			      gdouble   *yc,
			      gdouble   *rc,
			      gint      nsol,   /* number of found circles */
			      gdouble   x,      /* cursor coordinates */
			      gdouble   y,
			      gdouble   *x1c,   /* circle to draw */
			      gdouble   *y1c,
			      gdouble   *r1,
			      gint      *pos);  /* position in 0-nsol */
                  
/*---------------------------------------------*/

void math_apollonius(OBJECT **obj,   /* selected objects */
		     gdouble *xo,     /* field of found circles */
		     gdouble *yo,
		     gdouble *ro,
		     gint    *nsol    /* number of solutions */
		     );


/*===================================================================*/

void math_circle_tangent(gdouble r0,      /* radius of circle */
			 OBJECT **obj,   /* selected objects */
			 gdouble *xo,     /* field of found circles */
			 gdouble *yo,
			 gdouble *ro,
			 gint    *nsol    /* number of solutions */
			 );

/*------------------------------------------
  Line from  point p and tangent to circle 
  Return TRUE if line was found.
-------------------------------------------*/

gboolean math_tangent_CP_2D(OBJECT_CIRCLE  *c,  
			    POINT   *p,
			    POINT   *u1,
			    POINT   *u2);

/*----------------------------------------
 Line from point p and tangent to ellipse
------------------------------------------*/

gboolean math_tangent_EP_2D(OBJECT_ELLIPSE  *e,   
			    POINT    *p,
			    POINT    *u1,
			    POINT    *u2);


