/* oCADis
 * Copyright (C) 2001 Jonas Jarvoll
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* --  I N C L U D E S  -- */
#include <gtk/gtk.h>
#include <string.h>
#include "struct.h"


/* --  G L O B A L   V A R I A B L E S  -- */

/* --  L O C A L   V A R I A B L E S  -- */


/* --  F U N C T I O N S  -- */
TEXTSTYLE *textstyle_find(DOCUMENT *doc, gchar *name)
{
  GList *list;

  list=doc->textstyle_list;

  while(list!=NULL)
    {
      if(!strcmp( ((TEXTSTYLE *)list->data)->name, name))
	return (TEXTSTYLE *)list->data;

      list=g_list_next(list);
    }


  return NULL;

}



TEXTSTYLE *textstyle_new(DOCUMENT *doc, gint row, gchar *name, gint type, gint flags,
			 gdouble height, gdouble oblique, gdouble width)
{
  TEXTSTYLE *temp;

  temp=(TEXTSTYLE *)g_malloc(sizeof(TEXTSTYLE));

  temp->name=g_strdup(name);
  temp->type=type;

  temp->flags=flags;
  temp->height=height;
  temp->width=width;  
  temp->oblique=oblique;

  temp->doc=doc;

  if(row==-1)
    doc->textstyle_list=g_list_append(doc->textstyle_list,temp);
  else
    doc->textstyle_list=g_list_insert(doc->textstyle_list,temp, row);
  
  return temp;
}







