/* oCADis
 * Copyright (C) 2001 Jonas Jarvoll
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* --  I N C L U D E S  -- */
#include <gtk/gtk.h>
#include "struct.h"
#include "struct/grdraw.h"
#include "global.h"
#include "misc.h"
#include "dia_coords.h"
#include "dia_comm.h"
#include "xor.h"
#include "select.h"
#include "dimension.h"
#include "redraw.h"
#include "parse.h"
#include "tool_erase.h"
#include "translation.h"

/* --  G L O B A L   V A R I A B L E S  -- */

/* --  L O C A L   V A R I A B L E S  -- */


/* --  F U N C T I O N S  -- */
void tool_set_prompt_align(void)
{
  switch(gl_stage)
    {
    case 0: 
      set_prompt_text( _("Source line start point: "));
      break;
    case 1: 
      set_prompt_text( _("Source line end point: "));
      break;
    case 0: 
      set_prompt_text( _("Destination line start point: "));
      break;
    case 1: 
      set_prompt_text( _("Destination line end point: "));
      break;
    }
}

void tool_button_align(DOCUMENT *doc, gint button, gdouble x, gdouble y)
{
  TRANSFORM transform;

  /* Right mousebutton => cancel/break */
  if(button==3)
    {
      remove_old();
      print( _("*Cancel*"));
      deselect_all_objects(doc);
      tool_idle(doc);
      return;
    }

  switch(gl_stage)
    {
    case 0:
      if(doc->gl_snap)
	make_snap(doc, &x, &y);
      gl_oldmx=x;
      gl_oldmy=y;
      gl_stage=1;
      set_prompt();
      break;
    case 1:
      remove_old();
      make_ortho_snap(doc,gl_oldmx, gl_oldmy, &x, &y);
      /* Make tranform matrix */
      transform.type=OBJ_TRANSLATE;
      transform.trans_x=x-gl_oldmx;
      transform.trans_y=y-gl_oldmy;
      move_objects(doc, &transform);
      deselect_all_objects(doc);
      doc->saved=FALSE;
      make_window_title(doc);
      tool_idle(doc);
      break;
    }
}




