/* oCADis
 * Copyright (C) 2001 Jonas Jarvoll
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* --  I N C L U D E S  -- */
#include <gtk/gtk.h>
#include "struct.h"
#include "global.h"
#include "misc.h"
#include "dia_coords.h"
#include "dia_comm.h"
#include "xor.h"
#include "select.h"
#include "obj_line.h"
#include "obj_circle.h"
#include "obj_arc.h"
#include "redraw.h"
#include "parse.h"
#include "translation.h"


/* --  G L O B A L   V A R I A B L E S  -- */

/* --  L O C A L   V A R I A B L E S  -- */


/* --  F U N C T I O N S  -- */
void tool_set_prompt_idpoint(void)
{
  set_prompt_text( _("Point: "));
}

void tool_set_tool_idpoint(GtkWidget *widget, gpointer data)
{
  remove_old();
 
  if(!command_from_keyboard)
    print( _("idpoint"));

  if(work_document!=NULL)
    deselect_all_objects(work_document);
  
  if(misc_tool_get_document()==NULL)
    return;

  gl_tool=TOOL_IDPOINT;
  gl_stage=0;
  work_document=NULL;

  UpdateCoordsLabel();

  set_prompt();

  work_document=NULL;
}

void tool_button_idpoint(DOCUMENT *doc, gint button, gdouble x, gdouble y)
{
  /* Right mousebutton => cancel/break */
  if(button==3)
    {
      remove_old();
      print( _("*Cancel*"));
      tool_idle(doc);
      return;
    }

  if(gl_stage==0)
    {
      if(doc->gl_snap)
	make_snap(doc, &x ,&y);
      print( _("\n  X = %f, Y = %f"),x,y);
      tool_idle(doc);
    }
}

void tool_prompt_idpoint(DOCUMENT *doc, gchar *buffer)
{
  gdouble tx, ty;

  switch(parse_prompt(PROMPT_OSNAP|PROMPT_RETURN|PROMPT_POINT2,buffer,
		      FALSE,NULL,0,0,&tx,&ty,NULL,NULL))
    {
    case PROMPT_RETURN:
      remove_old();
      tool_idle(doc);
      break;
    case PROMPT_POINT2:
      work_document=doc;
      remove_old();
      tool_button_idpoint(doc,1,tx,ty);
      break;
    case PROMPT_ERROR:
    default:
      return;
    }
}



